function [tpr tnr accu] = acc(im, mask, man)
%
%    Performance measurement
%  
%               Inputs:
%                     im      -   input image
%                     mask    -   image mask  
%                     man     -   ground truth
% 
%               Outputs:
%                     tpr     -   true positive rate
%                     tnr     -   true negative rate
%                     accu    -   accuracy
%

% AUTHOR    Bob Zhang <yibo@pami.uwaterloo.ca>

im = logical(im);
mask = logical(mask);
man = logical(man);
im_size = size(im,1) * size(im,2);
[index] = find(mask(:) == 1);
tpr = sum(man(find(im(:) == 1))) / sum(man(index) == 1);
tnr = sum(man(find(im(:) == 0 & mask(:) == 1)) == 0) / sum(man(index) == 0);
accu = sum(im(index) == man(index)) / length(index);

return