function [Z] = main()
%
%    Main function that calls all others
%  
%               Outputs:
%                     Z(1,1)    -   true positive rate
%                     Z(1,2)    -   true negative rate
%                     Z(1,3)    -   accuracy
%

% AUTHOR    Bob Zhang <yibo@pami.uwaterloo.ca>

Z = zeros(20,3);

% maskForGDRange = zeros(1288,1936);
% for row = 1:1288
%     for col = 1:1936
%         if (row-644)*(row-644) + (col-968)*(col-968) > 62500
%             maskForGDRange(row,col) = 1;
%         end
%     end
% end
% 
% maskForGDRange = zeros(584,565);
% for row = 1:584
%     for col = 1:565
%         if (row-292)*(row-292) + (col-282)*(col-282) > 62500
%             maskForGDRange(row,col) = 1;
%         end
%     end
% end

maskForGDRange = zeros(605,700);
for row = 1:605
    for col = 1:700
        if (row-302)*(row-302) + (col-350)*(col-350) > 62500
            maskForGDRange(row,col) = 1;
        end
    end
end

% maskForGDRange = zeros(1152,1500);
% for row = 1:1152
%     for col = 1:1500
%         if (row-576)*(row-576) + (col-750)*(col-750) > 62500
%             maskForGDRange(row,col) = 1;
%         end
%     end
% end
idx = 1;
for k=[1:5 44 77 81:82 139 162:163 235:236 239 240 255 291 319 324]
    k 
%     mask_name = strcat('E:\Computer Vision\Copy of MatchFilter\stare-images\mask\im',num2str(k,'%04d'),'_mask.ppm');
    mask_name = strcat('D:\MyD 1\stare-images\mask\im',num2str(k,'%04d'),'_mask.ppm');
%     mask_name = strcat('C:\Documents and Settings\Administrator\My Documents\MATLAB\DRIVE\DRIVE\test\mask\',num2str(k,'%02d'),'_test_mask.gif');
    mask = imread(mask_name);
    mask = mask(:,:,2);
    mask = logical(mask);
%     se = strel('disk',5);
%     mask = imerode(mask,se);
%     im_name = strcat('E:\Computer Vision\Copy of MatchFilter\stare-images\im',num2str(k,'%04d'),'.ppm');
    im_name = strcat('D:\MyD 1\stare-images\im',num2str(k,'%04d'),'.ppm');
%     im_name = strcat('C:\Documents and Settings\Administrator\My Documents\MATLAB\DRIVE\DRIVE\test\images\',num2str(k,'%02d'),'_test.tif');
    im = imread(im_name);
%     mask = bwselect(im2bw(im(:,:,1), 20/255), size(im(:,:,1),1)/2, size(im(:,:,1),2)/2);
    se = strel('disk',2);
    mask=imerode(mask,se);
    im = double(im(:,:,2));
%     man_name = strcat('E:\Computer Vision\Copy of MatchFilter\stare-images\labels-ah\im',num2str(k,'%04d'),'.ah.ppm');
    man_name = strcat('D:\MyD 1\stare-images\labels-ah\im',num2str(k,'%04d'),'.ah.ppm');
%   man_name = strcat('C:\Documents and Settings\Administrator\My Documents\MATLAB\DRIVE\DRIVE\test\1st_manual\',num2str(k,'%02d'),'_manual1.gif');
    man = imread(man_name);
%     mfResutlFileName = strcat('E:\Computer Vision\Copy of MatchFilter\stare-images\MFResult\im',num2str(k,'%04d'),'.bmp');
%     mfResult = logical(imread(mfResutlFileName));
%     range = load(strcat('E:\Computer Vision\Copy of MatchFilter\stare-images\',num2str(k,'%04d'),'.txt'));

%     sigmaForMF = 1; %sigma for matched filter kernel
%     sigmaForGD = 1; % sigma for the first order gaussian derivative filter kernel
%     yLengthForMF = 11; % the length of the kernel for matched filter
%     yLengthForGD = 9; % the length of the kernel for the Gaussian Derivative filter kernel.
%     mask = bwselect(im2bw(im(:,:,1), 20/255), size(im(:,:,1),1)/2, size(im(:,:,1),2)/2);
%     mask = imerode(mask, strel('disk',5));
%%
    [vess1] = MatchFilterWithGaussDerivative([],1,im,1.5,1.5,9,5,41,201,8,mask,maskForGDRange,3,40);
    [vess2] = MatchFilterWithGaussDerivative([],2,im,1,1,9,5,21,101,8,mask,maskForGDRange,2,40);
    vess = vess1 | vess2;

    [tpr tnr accu] = acc(vess, mask, man);
    Z(idx,1,1) = tpr;
    Z(idx,2,1) = 1 - tnr;
    Z(idx,3,1) = accu;
    idx = idx + 1;
end
return

% idx=1;
% Z = zeros(20,3);
% for k=[1:5 44 77 81:82 139 162:163 235:236 239 240 255 291 319 324]
% im_name = strcat('C:\Users\admin\Documents\ken_src_vess\ken_src_vess\SRC\vessel_wavelet\soares\stare_gaussians20\im',num2str(k,'%04d'),'\im',num2str(k,'%04d'),'-class.png');
% im = imread(im_name);
% mask_name = strcat('D:\MyD 1\stare-images\mask\im',num2str(k,'%04d'),'_mask.ppm');
% mask = imread(mask_name);
% mask = mask(:,:,2);
% mask = logical(mask);
% man_name = strcat('D:\MyD 1\stare-images\labels-ah\im',num2str(k,'%04d'),'.ah.ppm');
% man = imread(man_name);
% [tpr tnr accu] = acc(im, mask, man);
% Z(idx,1,1) = tpr;
% Z(idx,2,1) = 1 - tnr;
% Z(idx,3,1) = accu;
% idx = idx + 1;
% end
% mean(Z)

% idx=1;
% Z = zeros(20,3);
% for k=1:20
%     im_name = strcat('C:\Users\admin\Documents\ken_src_vess\ken_src_vess\SRC\vessel_staal\',num2str(k,'%02d'),'_Staal_hard.jpg');
% % im_name = strcat('C:\Users\admin\Documents\ken_src_vess\ken_src_vess\SRC\vessel_wavelet\soares\drive_gaussians20\',num2str(k,'%02d'),'_test\',num2str(k,'%02d'),'_test-class.png');
% im = imread(im_name);
% im = im(:,:,2);
% im(find(im < 200)) = 0;
% im = logical(im);
% mask_name = strcat('C:\Users\admin\Documents\MATLAB\DRIVE\DRIVE\test\mask\',num2str(k,'%02d'),'_test_mask.gif');
% mask = imread(mask_name);
% mask = logical(mask);
% man_name = strcat('C:\Users\admin\Documents\MATLAB\DRIVE\DRIVE\test\1st_manual\',num2str(k,'%02d'),'_manual1.gif');
% man = imread(man_name);
% [tpr tnr accu] = acc(im, mask, man);
% Z(idx,1,1) = tpr;
% Z(idx,2,1) = 1 - tnr;
% Z(idx,3,1) = accu;
% idx = idx + 1;
% end
% mean(Z)